LeetCode: 1. 两数之和
Posted aoeiuvaqu
tags:
篇首语:本文由小常识网(cha138.com)小编为大家整理,主要介绍了LeetCode: 1. 两数之和相关的知识,希望对你有一定的参考价值。
题目描述:
给定一个整数数组 nums 和一个目标值 target,请你在该数组中找出和为目标值的那 两个 整数,并返回他们的数组下标。 你可以假设每种输入只会对应一个答案。但是,你不能重复利用这个数组中同样的元素。 示例: 给定 nums = [2, 7, 11, 15], target = 9 因为 nums[0] + nums[1] = 2 + 7 = 9 所以返回 [0, 1]
方法一:暴力法
暴力法很简单,遍历每个元素 x,并查找是否存在一个值与 target - x 相等的目标元素。
//暴力解法 public static int[] twoSum(int[] nums, int target) for (int i = 0; i < nums.length; i++) for (int j = i + 1; j < nums.length; j++) if (nums[j] == target - nums[i]) return new int[] i,j; throw new IllegalArgumentException("NULL");
时间复杂度为O(n2);
空间复杂度为O(1);
方法二:两遍哈希
以空间换速度,将查找时间从 O(n) 降低到 O(1)。我用“近似”来描述,是因为一旦出现冲突,查找用时可能会退化到 O(n)。但只要你仔细地挑选哈希函数,在哈希表中进行查找的用时应当被摊销为 O(1)。
思路:
在第一次迭代中,将每个元素的值和它的索引添加到表中。然后,在第二次迭代中,将检查每个元素所对应的目标元素(target - nums[i])是否存在于表中。注意,该目标元素不能是nums[i] 本身!
//两遍哈希表 public static int[] twoSum(int[] nums, int target) Map<Integer, Integer> map = new HashMap<>(); for (int i = 0; i < nums.length; i++) map.put(nums[i], i); for (int i = 0; i < nums.length; i++) int ans = target - nums[i]; if (map.containsKey(ans) && map.get(ans) != i) return new int[] i, map.get(ans) ; throw new IllegalArgumentException("NULL");
时间复杂度为O(n);
空间复杂度为O(n);
方法三:一遍哈希
思路:
在进行迭代并将元素插入到表中的同时,回过头来检查表中是否已经存在当前元素所对应的目标元素。如果它存在,找到对应解,并立即将其返回
//一遍哈希表 public static int[] twoSum(int[] nums, int target) Map<Integer,Integer> map = new HashMap<>(); for(int i = 0; i < nums.length; i++) int ans = target - nums[i]; if(map.containsKey(ans)) return new int[] map.get(ans),i; map.put(nums[i], i); throw new IllegalArgumentException("NULL");
时间复杂度为O(n);
空间复杂度为O(n);
以上是关于LeetCode: 1. 两数之和的主要内容,如果未能解决你的问题,请参考以下文章
算法 Notes|LeetCode 1. 两数之和 - easy